//
//  IOBSFile.m
//  IOBSSDK
//
//  Created by Nicholas on 15/10/31.
//  Copyright © 2015年 Nicholas. All rights reserved.
//

#import "IOBSFile.h"
#import "IOBSUploadResponseInfo.h"


@interface IOBSFile()

@property (nonatomic, readonly) NSString *filepath;

@property (nonatomic, copy) NSString *fileName;

@property (nonatomic) NSData *data;

@property (readonly)  int64_t fileSize;

@property (nonatomic) NSFileHandle *file;


@end

@implementation IOBSFile

- (instancetype)init:(NSString *)path
               error:(NSError *__autoreleasing *)error {
    
    if (self = [super init]) {
        _filepath = path;
    
        NSError *error2 = nil;
        NSDictionary *fileAttr = [[NSFileManager defaultManager] attributesOfItemAtPath:path error:&error2];
        if (error2 != nil) {
            if (error != nil) {
                *error = error2;
            }
            return self;
        }
        
        _fileSize = [fileAttr fileSize];
//
        _fileName = [path lastPathComponent];
        NSFileHandle *fileHandle = nil;
        NSData *data = nil;

        if (_fileSize > 16*1024*1024) {
            
            fileHandle = [NSFileHandle fileHandleForReadingAtPath:path];
            if (fileHandle == nil) {
                if (error != nil) {
                    
                    *error =[[NSError alloc] initWithDomain:path code:InvalidFile userInfo:nil];
                }
                return self;
            }
        }else{
            data = [NSData dataWithContentsOfFile:path options:NSDataReadingMappedIfSafe error:&error2];
            if (error2 != nil) {
                if (error != nil) {
                    *error = error2;
                }
                return self;
            }
        }
        _file = fileHandle;
        _data = data;
    }
    
    return self;
}

- (NSData *)read:(long)offset
            size:(long)size {
    if (_data != nil) {
        return [_data subdataWithRange:NSMakeRange(offset, (unsigned int)size)];
    }
    [_file seekToFileOffset:offset];
    return [_file readDataOfLength:size];
}


- (NSData *)readAll {
    return [self read:0 size:(long)_fileSize];
}

- (NSString *)fileName {
    return _fileName;
}


- (void)close {
    if (_file != nil) {
        [_file closeFile];
    }
}

-(NSString *)path {
    return _filepath;
}

- (int64_t)size {
    return _fileSize;
}


@end
