//
//  IOBSFileDelegate.h
//  IOBSSDK
//
//  Created by Nicholas on 15/10/31.
//  Copyright © 2015年 Nicholas. All rights reserved.
//

#import <Foundation/Foundation.h>

/**
 *    文件处理接口，支持ALAsset, NSFileHandle, NSData
 */
@protocol IOBSFileDelegate <NSObject>

/**
 *    从指定偏移读取数据
 *
 *    @param offset 偏移地址
 *    @param size   大小
 *
 *    @return 数据
 */
- (NSData *)read:(long)offset
            size:(long)size;

/**
 *    读取所有文件内容
 *
 *    @return 数据
 */
- (NSData *)readAll;

/**
 *    关闭文件
 *
 */
- (void)close;

/**
 *    文件路径
 *
 *    @return 文件路径
 */
- (NSString *)path;

/**
 *    文件大小
 *
 *    @return 文件大小
 */
- (int64_t)size;
- (NSString *)fileName;
@end
