//
//  IOBSHttpDelegate.h
//  IOBSSDK
//
//  Created by Nicholas on 15/10/31.
//  Copyright © 2015年 Nicholas. All rights reserved.
//

#import <Foundation/Foundation.h>

@class IOBSUploadResponseInfo;
@class IOBSUploadOption;
typedef void (^IOBSUploadCompletionHandler)(IOBSUploadResponseInfo *info, NSString *key, NSDictionary *resp);
typedef void (^IOBSInternalProgressBlock)(long long totalBytesWritten, long long totalBytesExpectedToWrite);
typedef void (^IOBSCompleteBlock)(IOBSUploadResponseInfo *info, NSDictionary *resp);

@protocol IOBSHttpDelegate <NSObject>

- (void)             post:(NSString *)url
                 withData:(NSData *)data
                    token:(NSString *)token
                     date:(NSString *)date
                 mimeType:(NSString *)mimeType
               withParams:(NSDictionary *)params
        withCompleteBlock:(IOBSCompleteBlock)completeBlock
        withProgressBlock:(IOBSInternalProgressBlock)progressBlock;

- (void)             post:(NSString *)url
                    token:(NSString *)token
                     date:(NSString *)date
               withParams:(NSDictionary *)params
        withCompleteBlock:(IOBSCompleteBlock)completeBlock;

- (void) putFileWithData:(NSData *)data
                  bucket:(NSString *)bucket
                     key:(NSString *)key
                   token:(NSString *)token
                    date:(NSString *)date
                complete:(IOBSUploadCompletionHandler)completionHandler
                  option:(IOBSUploadOption *)option;

//cxfix
// e.g baseUrl @"http://iobs.pingan.com/"
- (void) putFileWithData:(NSData *)data
                  bucket:(NSString *)bucket
                     key:(NSString *)key
                   token:(NSString *)token
                    date:(NSString *)date
                complete:(IOBSUploadCompletionHandler)completionHandler
                  option:(IOBSUploadOption *)option
             withBaseUrl:(NSString *)baseUrl;

- (void) putFileWithData:(NSData *)data
                  bucket:(NSString *)bucket
                     key:(NSString *)key
                   token:(NSString *)token
                    date:(NSString *)date
                complete:(IOBSUploadCompletionHandler)completionHandler
                  option:(IOBSUploadOption *)option
             withBaseUrl:(NSString *)baseUrl
                 coverid:(NSString *)coverid;

- (void) durativeUploadFileWithData:(NSData *)data
                fileName:(NSString *)fileName
                  bucket:(NSString *)bucket
                     key:(NSString *)key
                   token:(NSString *)token
                   index:(NSInteger)index
                complete:(IOBSUploadCompletionHandler)completionHandler
                  option:(IOBSUploadOption *)option
             withBaseUrl:(NSString *)baseUrl;

- (void) durativeUploadFileWithData:(NSData *)data
                           fileName:(NSString *)fileName
                             bucket:(NSString *)bucket
                                key:(NSString *)key
                              token:(NSString *)token
                              index:(NSInteger)index
                           complete:(IOBSUploadCompletionHandler)completionHandler
                             option:(IOBSUploadOption *)option
                        withBaseUrl:(NSString *)baseUrl
                            coverid:(NSString *)coverid;

- (void) finishUploadFileWithData:(NSData *)data
                fileName:(NSString *)fileName
                  bucket:(NSString *)bucket
                     key:(NSString *)key
                   token:(NSString *)token
                   index:(NSInteger)index
                  length:(long)length
                complete:(IOBSUploadCompletionHandler)completionHandler
                  option:(IOBSUploadOption *)option
             withBaseUrl:(NSString *)baseUrl;

- (void) finishUploadFileWithData:(NSData *)data
                         fileName:(NSString *)fileName
                           bucket:(NSString *)bucket
                              key:(NSString *)key
                            token:(NSString *)token
                            index:(NSInteger)index
                           length:(long)length
                         complete:(IOBSUploadCompletionHandler)completionHandler
                           option:(IOBSUploadOption *)option
                      withBaseUrl:(NSString *)baseUrl
                          coverid:(NSString *)coverid;
@end
