//
//  IOBSFederationToken.m
//  ObsTest
//
//  Created by zengpeng006 on 2017/7/31.
//  Copyright © 2017年 zengpeng006. All rights reserved.
//

#import "IOBSUploadToken.h"

@interface IOBSUploadToken ()
@property (nonatomic, strong) NSObject *lock;
@property (nonatomic, strong) NSCondition *condition;
@property (nonatomic, assign, readwrite, getter=isCompleted) BOOL completed;

@end


@implementation IOBSUploadToken


- (id)init{
    if (self = [super init]) {
        _lock = [[NSObject alloc] init];
        _condition = [[NSCondition alloc] init];
        _completed = NO;
    }
    return self;
}


- (void)setAuthorization:(NSString *)Authorization{
    @synchronized(self.lock) {
        if (self.completed) {
            return;
        }
        self.completed = YES;
        _Authorization = Authorization;
        [self.condition lock];
        [self.condition broadcast];
        [self.condition unlock];
    }

}
- (void)setDate:(NSString *)date{
    @synchronized(self.lock) {
        if (self.completed) {
            return;
        }
        _date = date;
        [self.condition lock];
        [self.condition broadcast];
        [self.condition unlock];
        
    }
}

- (void)setError:(NSError *)error{
    @synchronized(self.lock) {
        if (self.completed) {
            return;
        }
        self.completed = YES;
        [self.condition lock];
        [self.condition broadcast];
        [self.condition unlock];
        
    }
}

- (BOOL)isCompleted {
    @synchronized(self.lock) {
        return _completed;
    }
}

- (void)waitUntilFinished {
    if ([NSThread isMainThread]) {
        NSLog(@"main Thread wait");
    }
    
    @synchronized(self.lock) {
        if (self.completed) {
            return;
        }
        [self.condition lock];
    }
    while (!self.completed) {
        [self.condition wait];
    }
    [self.condition unlock];
}

@end
