//
//  IOBSUploadOption.m
//  IOBSSDK
//
//  Created by Nicholas on 15/10/31.
//  Copyright © 2015年 Nicholas. All rights reserved.
//

#import "IOBSUploadOption.h"
#import "IOBSUploadManager.h"

@implementation IOBSUploadOption

- (instancetype)initWithProgressHandler:(IOBSUpProgressHandler)progress
{
    return [self initWithProgressHandler:progress cancellationSignal:nil];
}

- (instancetype)initWithProgressHandler:(IOBSUpProgressHandler)progress
                     cancellationSignal:(IOBSUpCancellationSignal)cancellation
{
    if (self = [super init]) {
        _progressHandler = progress != nil ? progress : ^(NSString *key, float percent) {
        };
        _cancellationSignal = cancellation != nil ? cancellation : ^BOOL () {
            return NO;
        };
    }
    return self;
}

+(instancetype)defaultOptions
{
    return [[IOBSUploadOption alloc]initWithProgressHandler:nil cancellationSignal:nil];
}


@end
