//
//  IOBSDeleteManager.m
//  lobsSDK
//
//  Created by chenjie on 15/10/20.
//  Copyright © 2015年 PingAn. All rights reserved.
//

#import "IOBSDeleteManager.h"

@implementation IOBSDeleteManager


#pragma mark 删除文件
- (void)deleteFileWithUrl:(NSString *)urlString
        completionHandler:(IOBSDeleteCompletionHandler) handler
{
    NSURL *url = [NSURL URLWithString:urlString];
    NSMutableURLRequest *request = [NSMutableURLRequest requestWithURL:url];
    request.HTTPMethod = @"DELETE";
    NSURLSession *session = [NSURLSession sharedSession];
    NSURLSessionDataTask *task = [session dataTaskWithRequest:request
                                            completionHandler:^(NSData *_Nullable data, NSURLResponse * _Nullable response, NSError * _Nullable error) {
//                                                NSLog(@"%@---%@---%@",data,response,error.localizedDescription);
                                                NSHTTPURLResponse *response1 = (NSHTTPURLResponse *)response;
                                                if (response1.statusCode == 200 || error) {
                                                    dispatch_async(dispatch_get_main_queue(), ^{
                                                        if (handler) {
                                                            handler(response1.statusCode,error);
                                                        }
                                                    });
                                                } else {
                                                    id json = [self JSONObjectWithData:data];
                                                    NSDictionary *userInfo = [NSDictionary dictionaryWithObjectsAndKeys:json[@"error"], NSLocalizedDescriptionKey, nil];
                                                    
                                                    NSError *newError = [NSError errorWithDomain:@"domain" code:response1.statusCode userInfo:userInfo];
                                                    dispatch_async(dispatch_get_main_queue(), ^{
                                                        if (handler) {
                                                            handler(response1.statusCode,newError);
                                                        }
                                                    });

                                                }
                                                
//                                                NSLog(@"%@---%ld-----%@",[[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding],response1.statusCode,error.localizedDescription);
                                            }];
    [task resume];
}
#pragma mark - 辅助
-(id)JSONObjectWithData:(NSData*)data
{
    return [NSJSONSerialization JSONObjectWithData:data options:NSJSONReadingMutableContainers error:nil];
}

@end
