//
//  MainViewController.m
//  ObsTest
//
//  Created by 罗建英(EX-LUOJIANYING001) on 2020/3/30.
//  Copyright © 2020 zengpeng006. All rights reserved.
//

#import "MainViewController.h"
#import "ObsSDK.h"

//请填入自己对应的参数
#define Bucket @""
#define Key @""
#define BaseUrl @""
//获取token地址
#define getTokenUrl    @"http://.../getMobileSign"

@interface MainViewController ()
@property(nonatomic,strong) IOBSUploadManager *upLoadManager;
@property(nonatomic,strong) UILabel *label;
@end

@implementation MainViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    self.view.backgroundColor = [UIColor whiteColor];
    self.title = @"测试demo";
    
    UIButton *btn = [UIButton buttonWithType:0];
    btn.backgroundColor = [UIColor orangeColor];
    btn.frame = CGRectMake(100, 100, 100, 100);
    [btn setTitle:@"发送图片" forState:UIControlStateNormal];
    [btn addTarget:self action:@selector(test) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:btn];
    btn.layer.cornerRadius = 6;
    
    self.label = [[UILabel alloc] initWithFrame:CGRectMake(20, 220, self.view.frame.size.width-40, 100)];
    self.label.numberOfLines = 0;
    self.label.textColor = [UIColor blackColor];
    self.label.textAlignment = NSTextAlignmentLeft;
    [self.view addSubview:self.label];
}
-(void)test{
    
    IOBSUploadOption *option = [[IOBSUploadOption alloc] initWithProgressHandler:^(NSString *key, float percent) {
        NSString *str = [NSString stringWithFormat:@"进度:%.2lf%%",percent*100];
        NSLog(@"%@",str);
        self.label.text = str;
    }];

    /**
     bucket：dev-test-sc
     key：ljy1
     baseUrl：http://obs-cn-shenzhen.pinganyun.com
     */
    NSString *filePath = [[NSBundle mainBundle] pathForResource:@"emiticon" ofType:@"png"];
    NSData *imageData = [NSData dataWithContentsOfFile:filePath];
    
    self.upLoadManager = [[IOBSUploadManager alloc] initWithTokenGeter:^IOBSUploadToken *(NSDictionary *signature) {
       return [self getToken:signature];
    }];
    [self.upLoadManager putFileWithData:imageData bucket:Bucket key:Key option:option withBaseUrl:BaseUrl complete:^(IOBSUploadResponseInfo *info, NSString *key, NSDictionary *resp) {
        if (info.isOK) {
            NSLog(@"success");
            self.label.text = @"上传成功";
        }else {
            NSLog(@"failure:%@",info.description);
            self.label.text = info.description;
        }
    }];
}
- (IOBSUploadToken *)getToken:(NSDictionary *)signature{
    
    NSLog(@"%@",signature);
    IOBSUploadToken * uploadtoken = [[IOBSUploadToken alloc] init];
    
    //请求token
    NSURLSessionConfiguration *sessionConfig = [NSURLSessionConfiguration defaultSessionConfiguration];
    NSURLSession *ssSession = [NSURLSession sessionWithConfiguration:sessionConfig delegate:nil delegateQueue:nil];
    NSString * contenttype = [signature[@"contentType"] stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLQueryAllowedCharacterSet]];
    NSString * datestr = signature[@"date"];//[signature[@"date"] stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLQueryAllowedCharacterSet]];
    NSString * url = [NSString stringWithFormat:getTokenUrl];
    NSMutableURLRequest *request = [NSMutableURLRequest requestWithURL:[NSURL URLWithString:url]];
    request.HTTPMethod = @"POST";
    NSDictionary *pa = [[NSDictionary alloc] initWithObjectsAndKeys:contenttype,@"contentType",datestr,@"date",signature[@"path"],@"uri",signature[@"method"],@"method", nil];
    NSError *error;
    NSData *jsonData = [NSJSONSerialization dataWithJSONObject:pa options:NSJSONWritingPrettyPrinted error:&error];
    NSString *jsonString  = [[NSString alloc]initWithData:jsonData encoding:NSUTF8StringEncoding];
    NSMutableString *mutStr = [NSMutableString stringWithString:jsonString];
//    NSRange range = {0,jsonString.length};
//    [mutStr replaceOccurrencesOfString:@" " withString:@"" options:NSLiteralSearch range:range];
//    NSRange range2 = {0,mutStr.length};
//    [mutStr replaceOccurrencesOfString:@"\n" withString:@"" options:NSLiteralSearch range:range2];
    NSMutableData *body = [NSMutableData data];
    [body appendData:[mutStr dataUsingEncoding:NSUTF8StringEncoding]];
    [request setHTTPBody:body];
    [request setValue:@"application/json" forHTTPHeaderField:@"Content-Type"];
    
    NSLog(@"获取token\nrequest:\t%@\nheader:\t%@\nbody:\t%@",request.URL.absoluteString,request.allHTTPHeaderFields, [[NSString alloc] initWithData:[request HTTPBody] encoding:NSUTF8StringEncoding]);
    
    NSURLSessionDataTask * task = [ssSession dataTaskWithRequest:request completionHandler:^(NSData * _Nullable data, NSURLResponse * _Nullable response, NSError * _Nullable error) {
        if (error) {
            [uploadtoken setError:error];
            return;
        }
        NSString * authtoken = [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
        NSLog(@"###***###%@",authtoken);
        
        [uploadtoken setAuthorization:authtoken];
        
    }];
    
    [task resume];
    
    [uploadtoken waitUntilFinished];
    //
    return uploadtoken;
}

@end
