//
//  IOBSDownloadManager.h
//  lobsSDK
//
//  Created by chenjie on 15/10/20.
//  Copyright © 2015年 PingAn. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "IOBSDownloadOption.h"
#import "IOBSDownloadResponseInfo.h"
#import "IOBSUploadToken.h"
typedef void (^IOBSDownloadCompletionHandler)(IOBSDownloadResponseInfo *info);
typedef IOBSUploadToken *(^IOBSTokenGeter)(NSDictionary * signature);

@interface IOBSDownloadManager : NSObject

/**
 @method        初始化
 
 @abstract      下载文件方法
 @params        tokenGeter 获取token回调
 
 */

- (id)initWithTokenGeter:(IOBSTokenGeter)tokenGeter;

/**
 @method        getFileWithUrl:currentProgress:completionHandler
 
 @abstract      下载文件方法
 @params        path 保存路径
 @params        completionHandler 下载完成后的回调
 
 */


- (void)downloadWithBucket:(NSString*)bucket
                      key:(NSString *)key
                     host:(NSString *)host
                 savePath:(NSString *)path
            downloadOption:(IOBSDownloadOption *)option
        completionHandler:(IOBSDownloadCompletionHandler)completionHandler;



@end
